#include "kcharsets.h"

const KCharsetConversionResult & KCharsets::convertTag(const char * tag) 
{ 
  int l;
  return convertTag(tag,l);
}

typedef struct
{
  char *tag;
  char *conversion;
}TagEntry;

static TagEntry tag_list[] =
{
  "&amp","&",
  "&bull","*",
  "&copy","\xA9",
  "&emdash","-",
  "&emsp"," ",
  "&endash","-",
  "&ensp"," ",
  "&gt",">",
  "&hellip","...",
  "&lt","<",
  "&nbsp"," ",
  "&quot","\"",
  "&reg","\xAE",
  "&trade","(tm)",
  "&","&",   // must be last entry in table
  NULL,NULL
};

const KCharsetConversionResult & KCharsets::convertTag(const char * tag,
						       int & len) 
{
  char buf[8];
  int count,taglen;

  // check tag for number
  if(*(tag + 1) == '#')
  {
    buf[0] = atoi(tag + 2);
    buf[1] = 0x00;
    m_Result.setResult(buf);
    len = strlen(tag);
  }

  // scan list for tag
  else
  {
    count = 0;
    while(tag_list[count].tag != NULL)
    {
      taglen = strlen(tag_list[count].tag);
      if(strncmp(tag,tag_list[count].tag,taglen) == 0)
      {
	m_Result.setResult(tag_list[count].conversion);
	len = taglen;
	break;
      }
      ++count;
    }

    // no matching tag - substitute a space code
    if(tag_list[count].tag == NULL)
    {
      m_Result.setResult(" ");
      len = strlen(tag);
    }
  }

  //printf("KCharSet: \"%s\" = \"%s\"",tag,(char*)m_Result); getchar();

  // return result and exit
  return(m_Result);
}
