#include "qpoint.h"
#include "qwidget.h"
#include <Fl.H>

QPoint QMouseEvent::g;

void QWidget::resize(int w, int h) 
{ 
  resize(x(),y(),w,h);
}

void QWidget::repaint()
{
  redraw();
}

void QWidget::repaint(bool erase)
{
  redraw();
}

void QWidget::draw() 
{ 
  //      QRect r(x(),y(),w(),h());
  QRect r(0,0,w(),h());
  m_bInPaint = true;
#ifndef USE_FL_WIDGET
  make_current();
#endif
  QPaintEvent pe(r);
  paintEvent(&pe);
  m_bInPaint = false;      
}

void QWidget::repaint(int x, int y, int w, int h, bool erase)
{
  damage(0,x,y,w,h);
  redraw();
}


void QWidget::resize(int _x, int _y, int _w, int _h)
{
  QSize old_size(width(), height());
  QSize new_size(_w,_h);
  QResizeEvent q(new_size,old_size);
  FLTK_PARENT_WIDGET::resize(_x,_y,_w,_h);  
  resizeEvent(&q);
}

void QWidget::setGeometry(int _x, int _y, int _w, int _h)
{
  resize(_x,_y,_w,_h);
}

void QWidget::resizeEvent( QResizeEvent *)
{
  //  cerr << "QWidget::resizeEvent\n";
  
}

void QWidget::FillMouseEvent(QMouseEvent * e)
{
/*
  int x = parent() ? Fl::event_x() - parent()->x() : Fl::event_x();
  int y = parent() ? Fl::event_y() - parent()->y() : Fl::event_y();
*/

  int x = Fl::event_x();
  int y = Fl::event_y();

  int b = Fl::event_state();
  int b1 = 0;
  if(b == FL_BUTTON1)
    b1 = LeftButton;
  else if(b== FL_BUTTON2)
    b1 = RightButton;
  else
    b1 = MidButton;
  
  e->setButton(b1);
  e->setPos(QPoint(x,y));
  e->setGlobalPos(QPoint(Fl::event_x(), Fl::event_y()));
}


int QWidget::handle(int event)
{
  int ret = 0;
  QMouseEvent e;
  
  switch(event) {
  case FL_PUSH:
    FillMouseEvent(&e);
    mousePressEvent(&e);
    ret = 1;
    break;
  case FL_RELEASE:
    FillMouseEvent(&e);
    mouseReleaseEvent(&e);
    ret = 1;
    break;
  }

  return ret;
}
