#include "http.h"
#include <Fl.H>
#include "html.h"

////////////////////////////////////////////////////////////

static void _CheckData(void * pt)
{
  HTTPConnection * pThis = (HTTPConnection*)pt;
  HTTPConnection::HTTPRequest * p = pThis->GetFinished();


  while(p) {
    if(p->newPage()) {
      pThis->HTML()->begin(p->getURL());
      
      pThis->HTML()->write((const char*)p->getBuffer());
      
      pThis->HTML()->end();
      pThis->HTML()->parse();
      
      pThis->HTML()->redraw();
      printf("docSize: x=%d y=%d\n",pThis->HTML()->docWidth(),
	     pThis->HTML()->docHeight());

    } else {
      pThis->HTML()->data(p->getURL(), (const char *)p->getBuffer(), 
			  p->getSize(), true);
    }
    delete p;
    p = pThis->GetFinished();
  }
  
  if(!pThis->m_bDocDone) {
    Fl::add_timeout(.5, _CheckData, pt);
  }
}

void HTTPConnection::BeginDataTimer()
{
  Fl::add_timeout(.5, _CheckData, (void*)this);
}

void HTTPConnection::do_size()
{
  printf("docSize: x=%d y=%d\n",m_pHTML->docWidth(),
	 m_pHTML->docHeight());

  if(m_pDocCallback)
    m_pDocCallback(0,m_pHTML->docWidth(), m_pHTML->docHeight());
}

////////////////////////////////////////////////////////////

